package gr.scharf.fullscreen;

import org.eclipse.ui.IWindowListener;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends AbstractUIPlugin {

	// The shared instance
	private static Activator plugin;
	
	/**
	 * The constructor
	 */
	public Activator() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
		getWorkbench().addWindowListener(new IWindowListener(){
			public void windowActivated(IWorkbenchWindow window) {}
			public void windowClosed(IWorkbenchWindow window) {}
			public void windowDeactivated(IWorkbenchWindow window) {}
			public void windowOpened(IWorkbenchWindow window) {
				// new windows should be full screen when in
				// full screen mode
				if(fFullScreen)
					window.getShell().setFullScreen(fFullScreen);
			}});
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}
	static boolean fFullScreen;
	static public void toggleFullscreen() {
		fFullScreen=!fFullScreen;
		IWorkbenchWindow[] windows = getDefault().getWorkbench().getWorkbenchWindows();
		for (int i = 0; i < windows.length; i++) {
			windows[i].getShell().setFullScreen(fFullScreen);
		}
	}

}
