package gr.scharf.fullscreen.handlers;

import gr.scharf.fullscreen.Activator;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.Command;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.State;
import org.eclipse.ui.handlers.HandlerUtil;

/**
 * Our sample handler extends AbstractHandler, an IHandler base class.
 * @see org.eclipse.core.commands.IHandler
 * @see org.eclipse.core.commands.AbstractHandler
 */
public class FullScreenHandler extends AbstractHandler {
	/**
	 * The constructor.
	 */
	public FullScreenHandler() {
	}

	/**
	 * the command has been executed, so extract extract the needed information
	 * from the application context.
	 */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		Command command = event.getCommand();

		try {
			HandlerUtil.toggleCommandState(command); 
		} catch (NoSuchMethodError e) {
			// ignore -- this might be eclipse 3.4 which 
			// cannot toggle commands...
			// in 3.4 we have to do this by hand....
			State state = command.getState("org.eclipse.ui.commands.toggleState");
			if(state!=null) 
				state.setValue(new Boolean(!((Boolean) state.getValue()).booleanValue()));
		}
		Activator.toggleFullscreen();
		return null;
	}
}
